(*-------------------------------------------------------------------------*)
(*                                                                         *)
(*  Amiga Oberon Library Module: MATHLIB              Date: 02-Nov-92      *)
(*                                                                         *)
(*    1991 by Fridtjof Siebert                                            *)
(*                                                                         *)
(*-------------------------------------------------------------------------*)

MODULE MATHLIB;

IMPORT m := MathIEEEDoubTrans, b := MathIEEEDoubBas;

PROCEDURE ACOS  *(x: LONGREAL): LONGREAL; (* Arc Cosinus  *) BEGIN RETURN m.Acos(x)            END ACOS;
PROCEDURE ASIN  *(x: LONGREAL): LONGREAL; (* Arc Sinus    *) BEGIN RETURN m.Asin(x)            END ASIN;
PROCEDURE ATAN  *(x: LONGREAL): LONGREAL; (* Arc Tangens  *) BEGIN RETURN m.Atan(x)            END ATAN;
PROCEDURE ATANH *(x: LONGREAL): LONGREAL; (* Arc Tan. hyp.*) BEGIN RETURN m.Log((1+x)/(1-x))/2 END ATANH;
PROCEDURE COS   *(x: LONGREAL): LONGREAL; (* Cosinus      *) BEGIN RETURN m.Cos(x)             END COS;
PROCEDURE COSH  *(x: LONGREAL): LONGREAL; (* Cosinus hyp. *) BEGIN RETURN m.Cosh(x)            END COSH;
PROCEDURE ETOX  *(x: LONGREAL): LONGREAL; (* e^x          *) BEGIN RETURN m.Exp(x)             END ETOX;
PROCEDURE LOG10 *(x: LONGREAL): LONGREAL; (* 10er-Log.    *) BEGIN RETURN m.Log10(x)           END LOG10;
PROCEDURE LOG2  *(x: LONGREAL): LONGREAL; (* 2 er-Log.    *) BEGIN RETURN m.Log(x)/m.Log(2)    END LOG2;
PROCEDURE LOGN  *(x: LONGREAL): LONGREAL; (* nat. Log.    *) BEGIN RETURN m.Log(x)             END LOGN;
PROCEDURE SIN   *(x: LONGREAL): LONGREAL; (* Sinus        *) BEGIN RETURN m.Sin(x)             END SIN;
PROCEDURE SINH  *(x: LONGREAL): LONGREAL; (* Sinus hyp.   *) BEGIN RETURN m.Sinh(x)            END SINH;
PROCEDURE SQR   *(x: LONGREAL): LONGREAL; (* Quadrat      *) BEGIN RETURN x*x                  END SQR;
PROCEDURE SQRT  *(x: LONGREAL): LONGREAL; (* Wurzel       *) BEGIN RETURN m.Sqrt(x)            END SQRT;
PROCEDURE TAN   *(x: LONGREAL): LONGREAL; (* Tangens      *) BEGIN RETURN m.Tan(x)             END TAN;
PROCEDURE TANH  *(x: LONGREAL): LONGREAL; (* Tangens hyp. *) BEGIN RETURN m.Tanh(x)            END TANH;
PROCEDURE TENTOX*(x: LONGREAL): LONGREAL; (* 10^x         *) BEGIN RETURN m.Pow(x,10)          END TENTOX;
PROCEDURE TWOTOX*(x: LONGREAL): LONGREAL; (* 2^x          *) BEGIN RETURN m.Pow(x,2)           END TWOTOX;
PROCEDURE INT   *(x: LONGREAL): LONGREAL; (* 2^x          *) BEGIN IF x<0 THEN RETURN b.Ceil(x) ELSE RETURN b.Floor(x) END END INT;

END MATHLIB.

